/**
 * @author
 *  Behrooz Badii 	bb2122@columbia.edu
 *  Hanhua Feng         hanhua@cs.columbia.edu
 *  Edan Harel 	        edan@columbia.edu
 */
package CookieCutter.g6;

import CookieCutter.*;
import CookieCutter.g6.*;

public class Group6Player1 extends Group6Wrapper {

    public CookieCutterProblem.Solution solve( CookieCutterProblem prob, 
                                               Polygon pg ) {

        Polygon pgc = pg.dilate( DELTA+DELTA );

        if ( _copies == 1 )
        {
            try
            {
                CookieCutterProblem.Solution ret = prob.dumbSolver( pgc );
                if ( valid( pg, ret ) )
                    return ret;
            }
            catch ( Exception e )
            {
            }
        }

        Polygon pg0 = pgc.dilate( DELTA );

        CookieCutterProblem.Solution[] soln = new
            CookieCutterProblem.Solution[8];

        try 
        {
            soln[0] = prob.lessDumbSolver( pg0 );
            if ( !valid( pg, soln[0] ) )
                 soln[0] = null;
        }
        catch ( Exception e ) 
        {
            soln[0] = null;
        }

        try 
        {
            soln[1] = prob.pairSolver( pg0 );
            if ( !valid( pg, soln[1] ) )
                 soln[1] = null;
        }
        catch ( Exception e ) 
        {
            soln[1] = null;
        }

        try 
        {
            if ( _copies < 15 )
            {
                soln[2] = prob.greedySolver( pg0 );
                if ( !valid( pg, soln[2] ) )
                    soln[2] = null;
            }
        }
        catch ( Exception e ) 
        {
            soln[2] = null;
        }

/*        try 
        {
            soln[3] = prob.PuzzleSolver( pg, pg );
            if ( !valid( pg, soln[3] ) )
                soln[3] = null;
        }
        catch ( Exception e ) 
        {
            soln[3] = null;
        }
*/
        double rbound = 1E100;
        CookieCutterProblem.Solution ret = null;
        int index = -10000;

//        System.out.println( "Evaluating..." );

        for ( int i=0; i<soln.length; i++ )
            if ( soln[i] != null )
            {
                boolean compressed = false;
                CookieCutterProblem.Solution s = soln[i];
                try 
                {
                    s = prob.compress( soln[i], pgc );
                    if ( s == null || s.rbound >= soln[i].rbound 
                         || !valid( pg, s ) )
                        s = soln[i];
                    else
                        compressed = true;
                }
                catch( Exception e )
                {
                    compressed = false;
                    s = soln[i];
                }

//                if ( ! compressed )
//                    System.out.println( "The compressor returns false" );

                if ( s.rbound <= rbound )
                {
                    rbound = s.rbound;
                    ret = s;
                    if ( compressed )
                        index = i;
                    else
                        index = -i;
                }
            }

//        System.out.println( _name + ": Cutter #" + index + " wins." );

        if ( ret != null )
            return ret;

        return prob.dumbSolver( pg );
    }
}
